from typing import Any, Protocol, TypeVar

Self = TypeVar("Self")


class Step(Protocol):
    def __eq__(self, other: Any, /) -> bool: ...
    def __lt__(self, other: Any, /) -> bool: ...
    def __neg__(self: Self) -> Self: ...
    def __mul__(self: Self, other: int, /) -> Self: ...
    def __truediv__(self, other: Any, /) -> float: ...


class Point(Protocol):
    def __eq__(self, other: Any, /) -> bool: ...
    def __lt__(self, other: Any, /) -> bool: ...
    def __le__(self, other: Any, /) -> bool: ...
    def __add__(self: Self, other: Any, /) -> Self: ...
    def __sub__(self: Self, other: Self, /) -> Step: ...
